;--TERMOSTAT-------------------)S(01.2002
; slovak@post.cz
;
; CP=OFF WDog=ON Put=ON Osc=HS
;
; Xtal=20MHz
; Displej spolecna Anoda(+)
;
; Leve tlacitko  - Minus
; Prostredni tl. - Plus
; Prave tlacitko - Dalsi (postupne prepinani zobrazeni na displeji)
;
;    displej: teplota -19.9 az 99.9 [stupne Celsia]
;           : L = mez Low -19 az 99
;           : H = mez High -19 az 99
;_     ___  : P = cislo Programu regulace 0 az 5
; |___|   |_: A = cas pro ReLow ZAP 00-FFhex (00=nejdelsi cas, jako 100hex)
;           : b = cas pro ReLow VYP 00-FFhex (00=necasuje, imp=0)
; |-A-|-b-| : C = cas pro ReHig ZAP 00-FFhex (00=nejdelsi cas, jako 100hex)
; |-C-|-d-| : d = cas pro ReHig VYP 00-FFhex (00=necasuje, imp=0)
;                                            (01=nejkratsi cas, asi 0.15s)
;  Program 0: vystupy RHi RLo 0=zap
;          1: pouze pro RHi s hysterezi podle H a L
;             na vystupu RLo jsou impulzi (frekvence je umerna teplote)
;    2,3,4,5: mez H ovlada RHi podle tabulky
;             mez L ovlada RLo podle tabulky
;
;       | 0   1   2   3   4   5  Program regulace
; meze  |
;       | 1  v1  imp v1  imp  0
;  H   -|--------------------------- }vystup ReHig
;       | 1      ^1  imp ^1  ^1
;       |                    imp-teplota stoupa
;       |
;       |                    imp-teplota klesa
;       | 1      imp v1  v1  v1
;  L   -|--------------------------- }vystup ReLow
;       | 1  ^0  ^1  imp imp  0
;       |  
;       ^
;       teplota
;
;  ^v = vcetne (pri rovnosti teploty a meze plati jeste tento stav)
;   1 = vystup rele VYP
;   0 = vystup rele ZAP
; imp = casove prepinani rele podle nastavenych casu
;
;----------------------------------------

 LIST P=16F84, R=DEC			; direktivy prekladace

 include<p16f84.inc>			; definice nazvu registru

T0		EQU	0x0C		;vysledna teplota (desetiny)
T1		EQU	0x0D		;                 (jednicky)
T2		EQU	0x0E		;                 (desitky)
Priznak		EQU	0x0F		;priznakove bity

					;pro matematicke a (jine) funkce
A1		EQU	0x10		;(Vzorky)
A2		EQU	0x11		;(pamet pro Segment)
A3		EQU	0x12		;(MemW)
B1		EQU	0x13		;(H1 delka urovenH 1)
B2		EQU	0x14		;(H2 delka urovenH 2)
B3		EQU	0x15		;
C1		EQU	0x16		;(Kolikrat)
C2		EQU	0x17		;
C3		EQU	0x18		;
D1		EQU	0x19		;(SH1 suma urovneH 1)
D2		EQU	0x1A		;(SH2 suma urovneH 2)
D3		EQU	0x1B		;(SH3 suma urovneH 3)
D4		EQU	0x1C		;(SP1 suma perioda 1)
D5		EQU	0x1D		;(SP2 suma perioda 2)
D6		EQU	0x1E		;(SP3 suma perioda 3)
P1		EQU	0x1F		;(P1 delka periody 1)
P2		EQU	0x20		;(P2 delka periody 2)
P3		EQU	0x21		;  (1=nizsi, 2=vyzsi, 3=nejvyzsi bajt)

CDisplej	EQU	0x22		;citac pro displej
DPoradi		EQU	0x23		;poradi displeje
Disp0  		EQU	0x24		;znak na displeji
Disp1  		EQU	0x25		;
Disp2		EQU	0x26		;
MOD		EQU	0x27		;cislo modu
KlvPort		EQU	0x28		;klavesnice
OC1		EQU	0x29		;Old C
OC2		EQU	0x2A		; pro Prumer
O1		EQU	0x2B		;Out teplota
O2		EQU	0x2C		; vystupni teplota pred -681
KC0		EQU	0x2D		;casovac Opakovani
KC1		EQU	0x3E		; KLV
Low1		EQU	0x2F		;dolni mez
Low2		EQU	0x30		;
Hig1		EQU	0x31		;horni mez
Hig2		EQU	0x32		;
TA		EQU	0x33		;CYKLOVAC Low
TB		EQU	0x34		;
TC		EQU	0x35		;CYKLOVAC Hig
TD		EQU	0x36		;
Prog		EQU	0x37		;cislo programu
PT1		EQU	0x38		;Prevod teplota/impuls
PT2		EQU	0x39		;
CImpuls		EQU	0x3A		;Citac pro impuls
Trend0          EQU     0x3B            ;teplota stoupa nebo klesa
Trend1          EQU     0x3C            ;
Trend2          EQU     0x3D            ;

TlM		EQU	3		;PORTB tlacitko MINUS
TlP		EQU	5		;PORTB tlacitko PLUS
TlD		EQU	4		;PORTB tlacitko DALSI
Vstup		EQU	0		;PORTB teplotni cidlo SMT 160-30
OD1		EQU	0		;PORTA anoda Disp1
OD2		EQU	1		;PORTA anoda Disp2
OD0		EQU	2		;PORTA anoda Disp0
ReLow		EQU	3		;PORTA vystup rele RLo
ReHig		EQU	4		;PORTA vystup rele Hig
VST		EQU	0		;Priznak vstup
Kl		EQU	7		;Priznak kladne
Pres		EQU	6		;Priznak stisknute tl.
Zapis		EQU	5		;Priznak pro zapis do EEPROM
Znam		EQU	4		;Priznak znamenko
ImpOut		EQU	3		;PORTA vystup impulsu

;----------------------------------------
; kod programu
;----------------------------------------

		ORG	0
		GOTO	Start		; skok na zacatek programu

		ORG	4		;
		GOTO	IntProc		; skok na obsluhu preruseni
;----------------------------------------
;--prevod cislo znaku/sedmisegment-------
Segment		MOVWF	A2		;
		SUBLW	0x24		;24-Seg
		MOVF	A2,W		;puvodni znak
		BTFSS	STATUS,C	;kladne?
		MOVLW	0x20		;NE, nahradit znak
		ADDWF	PCL,F		;ANO
		RETLW	0x05		;00/0
		RETLW	0xED		;01/1
		RETLW	0x83		;02/2
		RETLW	0xC1		;03/3
		RETLW	0x69		;04/4
		RETLW	0x51		;05/5
		RETLW	0x11		;06/6
		RETLW	0xCD		;07/7
		RETLW	0x01		;08/8
		RETLW	0x41		;09/9
		RETLW	0x09		;0A/A
		RETLW	0x31		;0B/b
		RETLW	0x17		;0C/C
		RETLW	0xA1		;0D/d
		RETLW	0x13		;0E/E
		RETLW	0x1B		;0F/F
		RETLW	0x29		;10/H
		RETLW	0x3F		;11/I
		RETLW	0xA5		;12/J
		RETLW	0x3B		;13/k
		RETLW	0x37		;14/L
		RETLW	0x0D		;15/M
		RETLW	0xB9		;16/n
		RETLW	0xB1		;17/o
		RETLW	0x0B		;18/P
		RETLW	0xBB		;19/r
		RETLW	0x33		;1A/t
		RETLW	0x35		;1B/u
		RETLW	0x45		;1C/V
		RETLW	0x2B		;1D/Y
		RETLW	0xFB		;1E/-
		RETLW	0xE9		;1F/-1(-10)
		RETLW	0xFF		;20/  (vypnuty displej)
		RETLW	0xF3		;21/= (-20)
		RETLW	0xD3		;22/. (-30)
		RETLW	0x79		;23/. (-40)
		RETLW	0xC5		;24/)
;----------------------------------------
IntProc		MOVF	TMR0,W		;casovac do W

		BTFSC	INTCON,T0IF	;preruseni od casovace?
		GOTO	Timer		;ANO

		MOVWF	B1		;casovac do H1
		BCF	Priznak,VST	;VST=0
		BCF	INTCON,INTF	;priz.prer.od vstupu=0
		RETFIE

Timer		INCF	P2,F		;P2+1
		BTFSC	Priznak,VST	;VST=0?
		INCF	B2,F		;NE, H2+1
		BCF	INTCON,T0IF	;priz.prer.od casovace=0
		RETFIE
;----------------------------------------
;--C1 * (D2,3 * 2) = B1,2,3--------------		
Posuv		MOVWF	C1		;kolikrat
		MOVF	D2,W
		MOVWF	A1
		MOVF	D3,W
		MOVWF	A2
		CLRF	A3
Znova		BCF	STATUS,C	;C=0
		RLF	A1,F		;posuv vlevo
		RLF	A2,F		;
		RLF	A3,F		;
		DECFSZ	C1,F		;kolikrat-1, =0?
		GOTO	Znova		;NE
		MOVF	A1,W
		ADDWF	B1,F		;B1+A1
		BTFSS	STATUS,C	;preteklo?
		GOTO	Plus2           ;NE
		INCFSZ	B2,F		;+1, =0?
		GOTO	Plus2           ;NE
		INCF	B3,F		;+1
Plus2		MOVF	A2,W
		ADDWF	B2,F		;B2+A2
		BTFSC	STATUS,C	;nepreteklo?
		INCF	B3,F		;+1
		MOVF	A3,W
		ADDWF	B3,F		;B3+A3
		RETURN
;--A1,2,3 - B1,2,3 = C1,2,3--------------
; A,B se nemeni. Pouziva P2,3
; C=1=kladne, C=0=zaporne
MINUS		MOVF	A2,W
		MOVWF	P2
		MOVF	A3,W
		MOVWF	P3
		BSF	Priznak,Kl	;Kl=1
		MOVF	B1,W
		SUBWF	A1,W		;A1-B1
		MOVWF	C1		;=C1
		BTFSC	STATUS,C	;zaporne?
		GOTO	Minus2		;NE
		MOVLW	1
		SUBWF	A2,F		;A2-1
		BTFSC	STATUS,C	;zaporne?
		GOTO	Minus2		;NE
		SUBWF	A3,F		;A3-1
		BTFSS	STATUS,C	;kladne?
		BCF	Priznak,Kl	;Kl=0
Minus2		MOVF	B2,W
		SUBWF	A2,W		;A2-B2
		MOVWF	C2		;=C2
		BTFSC	STATUS,C	;zaporne?
		GOTO	Minus3		;NE
		MOVLW	1
		SUBWF	A3,F		;A3-1
		BTFSS	STATUS,C	;kladne?
		BCF	Priznak,Kl	;Kl=0
Minus3		MOVF	B3,W
		SUBWF	A3,W		;A3-B3
		MOVWF	C3		;=C3
		BTFSS	Priznak,Kl	;kladne?
		BCF	STATUS,C	;C=0=zaporne
		MOVF	P2,W
		MOVWF	A2
		MOVF	P3,W
		MOVWF	A3
		RETURN
;--Test B1,2,3 na nulu-------------------
Nula		MOVF	B1,F
		BTFSS	STATUS,Z	;=0?
		RETURN			;ANO
		MOVF	B2,F
		BTFSS	STATUS,Z	;=0?
		RETURN			;ANO
		MOVF	B3,F
		RETURN
;--D1,2,3,4,5,6 * 2----------------------
Dx2		RLF	D1,F		;posuv vlevo
		RLF	D2,F		;
		RLF	D3,F		;
		RLF	D4,F		;
		RLF	D5,F		;
		RLF	D6,F		;
		RETURN
;--D4,5,6 do A1,2,3----------------------
D4A1		MOVF	D4,W		;DdoA
		MOVWF	A1		;
		MOVF	D5,W		;
		MOVWF	A2		;
		MOVF	D6,W		;
		MOVWF	A3		;
		RETURN
;--A1,2,3 / B1,2,3 = C1,2,3--------------
; pouziva D1,2,3,4,5,6; P1
; Z=1=deleni nulou
LOMENO		CALL	Nula
		BTFSC	STATUS,Z	;nenulove?
		RETURN
		MOVF	A1,W		;AdoD
		MOVWF	D1		;
		MOVF	A2,W		;
		MOVWF	D2		;
		MOVF	A3,W		;
		MOVWF	D3		;
		CLRF	D4		;nulovat
		CLRF	D5		;
		CLRF	D6		;
		MOVLW	25		;pocet bitu+1
		MOVWF	P1		;
Lom1		DECF	P1,F		;-1
		BTFSC	STATUS,Z	;nenulove?
		GOTO	LNula
		BCF	STATUS,C	;C=0
		CALL	Dx2
		CALL	D4A1
		CALL	MINUS
		BTFSS	STATUS,C	;kladne?
		GOTO	Lom1
LKlad		MOVF	C1,W		;CdoD
		MOVWF	D4		;
		MOVF	C2,W		;
		MOVWF	D5		;
		MOVF	C3,W		;
		MOVWF	D6		;
LZapor		CALL	Dx2
		DECF	P1,F		;-1
		BTFSC	STATUS,Z	;nenulove?
		GOTO	ELomeno		;konec
		CALL	D4A1
		CALL	MINUS
		BTFSS	STATUS,C	;kladne?
		GOTO	LZapor
		GOTO	LKlad
ELomeno		MOVF	D1,W		;DdoC
		MOVWF	C1		;
		MOVF	D2,W		;
		MOVWF	C2		;
		MOVF	D3,W		;
		MOVWF	C3		;
		RETURN
LNula		CLRF	C1		;vysledek
		CLRF	C2		; =0
		CLRF	C3		;
		RETURN
;--TEST KLV a OPAKOVANI------------------
; Z=0=neco stisknuto; Z=1=zadne tlacitko
KLV        	MOVF	KlvPort,W
		ANDLW	0x38		;00111000 1a1=1
		XORLW	0x38		;00111000 st.=0
		BTFSS	STATUS,Z	;nenulove? (zadne tlacitko)
		GOTO	Neco		;NE
		BCF	Priznak,Pres	;vynulovat priznak
		RETURN
Neco		BTFSS	Priznak,Pres	;=1?
		GOTO	Prvni		;NE
		DECFSZ	KC0,F		;-1, =0?
		GOTO	Nic		;NE
		DECFSZ	KC1,F		;-1, =0?
		GOTO	Nic		;NE
Prvni		CLRF	KC0		;casovac Klv
		MOVLW	2		; od
		MOVWF	KC1		; zacatku
		BSF	Priznak,Pres	;Pres=1
		BCF	STATUS,Z	;Z=0
		RETURN
Nic		BSF	STATUS,Z	;Z=1
		RETURN			;jako zadne tl.
;--TEST DIFERENCE------------------------
DifTest		CALL	MINUS		;A-B=C
		BTFSS	STATUS,C	;kladne?
		RETURN			;NE
		MOVF	C2,F
		BTFSS	STATUS,Z	;maly rozdil?
		GOTO	Big		;NE, rozdil>1C
		MOVF	C1,W
		SUBLW	10		;10-C1
		BTFSC	STATUS,C	;zaporne?
		GOTO	DTEnd           ;NE
Big		MOVF	D1,W		;okamzita
		MOVWF	O1		; zmena
		MOVF	D2,W		;
		MOVWF	O2		;
DTEnd		BSF	STATUS,C	;C=1
		RETURN
;--MINUS ZNAKY---------------------------
MZnaky		MOVWF	Disp2
		BTFSS	Disp2,7		;MSB=1?
		RETURN			;NE
		XORLW	0x80		;10000000
		BTFSC	STATUS,Z	;toto?
		GOTO	ZMinus		;ANO
		MOVF	Disp2,W
		XORLW	0x81		;10000001
		BTFSC	STATUS,Z	;toto?
		GOTO	ZMJedna		;ANO
		MOVF	Disp2,W
		XORLW	0x82		;10000010
		BTFSC	STATUS,Z	;toto?
		GOTO	ZMDva		;ANO
		MOVF	Disp2,W
		XORLW	0x83		;10000011
		BTFSC	STATUS,Z	;toto?
		GOTO	ZMTri		;ANO
		MOVLW	0x23		;znak (-40)
		RETURN
ZMinus		MOVLW	0x1E		;znak (-)
		RETURN
ZMJedna		MOVLW	0x1F		;znak (-10)
		RETURN
ZMDva		MOVLW	0x21		;znak (-20)
		RETURN
ZMTri		MOVLW	0x22		;znak (-30)
		RETURN
;--CTENI EEPROM--------------------------
ERead		BSF	STATUS,RP0	;reg.sada 1
		BSF	EECON1,RD	;cteni
		BCF	STATUS,RP0	;reg.sada 0
		MOVF	EEDATA,W
		RETURN
;--ZAPIS DO EEPROM-----------------------
EWrite		MOVWF	EEDATA
		BSF	STATUS,RP0	;reg.sada 1
		BSF	EECON1,WREN	;zapis povolen
		MOVLW	0x55		;uvodni
		MOVWF	EECON2		; sekvence
		MOVLW	0xAA		;
		MOVWF	EECON2		;
		BSF	EECON1,WR	;zapis
EEIF0		BTFSS	EECON1,EEIF	;konec zapisu?
		GOTO	EEIF0		;NE
		BCF	EECON1,WREN	;zapis zakazan
		BCF	EECON1,EEIF	;vynulovat priznak
		BCF	STATUS,RP0	;reg.sada 0
		RETURN
;--TEPLOTA>X-----------------------------
; C=0=ANO, C=1=NE
VETSI		ANDLW	0x80		;1000000
		BTFSS	STATUS,Z	;X=+?
		GOTO	VetsiTM		;NE, X=-
		BTFSC	T2,7		;T=+?
		GOTO	Ce1		;NE, T=-
VetsiMT		MOVF    T0,W		;TdoB
		MOVWF	B1		;
		MOVF	T1,W		;
		MOVWF	B2		;
		MOVF	T2,W		;
		MOVWF	B3		;
		CALL	MINUS		;X-T
		RETURN
VetsiTM		BTFSC	T2,7		;T=+?
 		GOTO	MensiTM         ;NE
;----------------------------------------
Ce0		BCF	STATUS,C
		RETURN
;--TEPLOTA<X-----------------------------
; C=0=ANO, C=1=NE
MENSI		ANDLW	0x80		;10000000
		BTFSS	STATUS,Z	;X=+?
		GOTO	MensiMT		;NE, X=-
		BTFSC	T2,7		;T=+?
		GOTO	Ce0		;NE, T=-
MensiTM		MOVF	T0,W		;TdoA
		MOVWF	A1		;
		MOVF	T1,W		;
		MOVWF	A2		;
		MOVF	T2,W		;
		MOVWF	A3		;
		CALL	MINUS		;T-X
		RETURN
MensiMT		BTFSC	T2,7		;T=+?
		GOTO	VetsiMT         ;NE
;----------------------------------------
Ce1		BSF	STATUS,C
		RETURN
;--Hig1,2 do A2,3 a B2,3-----------------
HdoAB		MOVF	Hig1,W
		MOVWF	A2
		MOVWF	B2
		MOVF	Hig2,W
		MOVWF	A3
		MOVWF	B3
		GOTO	EndAB
;--Low1,2 do A2,3 a B2,3-----------------
LdoAB		MOVF	Low1,W
		MOVWF	A2
		MOVWF	B2
		MOVF	Low2,W
		MOVWF	A3
		MOVWF	B3
EndAB		CLRF	A1
		CLRF	B1
		RETURN
;----------------------------------------
TrendAB		MOVF	Trend0,W
		MOVWF	A1
		MOVWF	B1
		MOVF	Trend1,W
		MOVWF	A2
		MOVWF	B2
		MOVF	Trend2,W
		MOVWF	A3
		MOVWF	B3
		RETURN
;----------------------------------------
NewTrend	MOVF	T0,W
		MOVWF	Trend0
		MOVF	T1,W
		MOVWF	Trend1
		MOVF	T2,W
		MOVWF	Trend2
		RETURN
;--CYKLOVAC Low--------------------------
TimL		MOVF	TB,F
		BTFSS	STATUS,Z	;=0?
		GOTO	TimL0		;NE
		DECFSZ	TA,F		;-1, =0?
		RETURN
		MOVLW	5		;adresa
		MOVWF	EEADR		; TB v EEPROM
		CALL	ERead
		MOVWF	TB		;od zacatku
		RETURN
TimL0		BSF	STATUS,C	;VYP
		DECFSZ	TB,F		;-1, =0?
		RETURN
		CALL	NewTrend
SetTA		MOVLW	4		;adresa
		MOVWF	EEADR		; TA v EEPROM
		CALL	ERead
		MOVWF	TA		;od zacatku
		RETURN
;--CYKLOVAC Hig--------------------------
TimH		MOVF	TD,F
		BTFSS	STATUS,Z	;=0?
		GOTO	TimH0		;NE
		DECFSZ	TC,F		;-1, =0?
		RETURN
		MOVLW	7		;adresa
		MOVWF	EEADR		; TD v EEPROM
		CALL	ERead
		MOVWF	TD		;od zacatku
		RETURN
TimH0		BSF	STATUS,C	;VYP
		DECFSZ	TD,F		;-1, =0?
		RETURN
		CALL	NewTrend
SetTC		MOVLW	6		;adresa
		MOVWF	EEADR		; TC v EEPROM
		CALL	ERead
		MOVWF	TC		;od zacatku
		RETURN
;--cyklovani Rele Low--------------------
ZVTLow		BTFSS	STATUS,C
		GOTO	ZVTL0
		CLRF	TB
		CALL	SetTA
		GOTO	ZVLow
ZVTL0		CALL	TimL
;--ZAP nebo VYP (podle C) Rele Low-------
ZVLow		BTFSS	STATUS,C
		BCF	PORTA,ReLow	;ZAP3
		BTFSC	STATUS,C
		BSF	PORTA,ReLow	;VYP3
		RETURN
;--cyklovani Rele Hig--------------------
ZVTHig		BTFSS	STATUS,C
		GOTO	ZVTH0
		CLRF	TD
		CALL	SetTC
		GOTO	ZVHig
ZVTH0		CALL	TimH
;--ZAP nebo VYP (podle C) Rele Hig-------
ZVHig		BTFSS	STATUS,C
		BCF	PORTA,ReHig	;ZAP4
		BTFSC	STATUS,C
		BSF	PORTA,ReHig	;VYP4
		RETURN
;++++++++++++++++++++++++++++++++++++++++
Start					;inicializace procesoru
		BSF	STATUS,RP0	;registrova sada 1
		MOVLW	0x0C		;00001100
		MOVWF	OPTION_REG	;nastaveni OPTION
		CLRF	TRISA		;piny PORTA jako vystupy
		MOVLW	0x01		;piny PORTB
		MOVWF	TRISB		; jako vystupy mimo RB0
		BCF	STATUS,RP0	;registrova sada 0
		CLRF	Priznak
		CLRF	MOD
		CLRF	A1
		BSF	Priznak,Pres
		MOVLW	2
		MOVWF	DPoradi
		MOVWF	CDisplej
		MOVWF	CImpuls
		MOVLW	245
		MOVWF	PT2
		MOVLW	0x24
		MOVWF	T2
		MOVLW	0x05
		MOVWF	T1
		MOVLW	0x0C
		MOVWF	T0
					;prvni cteni EEPROM
		CLRF	EEADR		;adresa=0
		CALL	ERead
		MOVWF	Low2		;dolni mez2
		ANDLW	0x70		;01110000
		BTFSS	STATUS,Z	;povolena hodnota?
		CLRF	Low2		;NE,=0
		INCF	EEADR,F		;adresa+1=1
		CALL	ERead
		MOVWF	Low1		;dolni mez1
		ANDLW	0xF0		;11110000
		BTFSS	STATUS,Z	;povolena hodnota?
		CLRF	Low1		;NE,=0
		INCF	EEADR,F		;adresa+1=2
		CALL	ERead
		MOVWF	Hig2		;horni mez2
		ANDLW	0x70		;01110000
		BTFSS	STATUS,Z	;povolena hodnota?
		CLRF	Hig2		;NE,=0
		INCF	EEADR,F		;adresa+1=3
		CALL	ERead
		MOVWF	Hig1		;horni mez1
		ANDLW	0xF0		;11110000
		BTFSS	STATUS,Z	;povolena hodnota?
		CLRF	Hig1		;NE,=0
		INCF	EEADR,F		;adresa+1=4
		CALL	ERead
		MOVWF	TA
		INCF	EEADR,F		;adresa+1=5
		CALL	ERead
		MOVWF	TB
		INCF	EEADR,F		;adresa+1=6
		CALL	ERead
		MOVWF	TC
		INCF	EEADR,F		;adresa+1=7
		CALL	ERead
		MOVWF	TD
		INCF	EEADR,F		;adresa+1=8
		CALL	ERead
		MOVWF	Prog		;cislo programu
		ANDLW	0xF8		;11111000
		BTFSS	STATUS,Z	;povolena hodnota?
		CLRF	Prog		;NE,=0

;****************************************
Main		CLRWDT			;kost pro psa
		CLRF	B2		;vynulovat H2
		CLRF	P2		;vynulovat P2
		BSF	Priznak,VST	;VST=1
;--MERENI--------------------------------
Vstup1		BTFSC	PORTB,Vstup	;vstup=0?
		GOTO	Vstup1		;NE
		MOVLW	0xB0		;priprava pro INTCON

MStart		BTFSS	PORTB,Vstup	;vstup=1?
		GOTO	MStart		;NE
		CLRF	TMR0		;casovac=0
		MOVWF	INTCON		;zap. preruseni

VST1		BTFSC	Priznak,VST	;VST=0?
		GOTO	VST1		;NE

MKonec		BTFSS	PORTB,Vstup	;vstup=1?
		GOTO	MKonec		;NE
		MOVF	TMR0,W		;casovac do W
Ivyp		BCF	INTCON,GIE	;vyp. preruseni
		BTFSC	INTCON,GIE	;opravdu vypnuto?
		GOTO	Ivyp		;NE
		MOVWF	P1		;casovac do P1

; v B1,B2 je delka urovne H            _____         _____
; v P1,P2 je delka Periody P      ____|     |_______|
;
;                   2128*H            |--H--|
; teplota[C]*10 = -------- - 681     |------P------|
;		      P

;Pro korekci chyb se secte 256 vzorku a potom se vydeli 256ti
;					(SH1 a SP1 se vypusti)
;--SOUCET H 256x SH+H=SH-----------------
		MOVF	B1,W
		ADDWF	D1,F		;SH1+H1
		BTFSS	STATUS,C	;preteklo?
		GOTO	SVPVJ		;NE
		INCFSZ	D2,F		;SH2+1, =0?
		GOTO	SVPVJ		;NE
		INCF	D3,F		;SH3+1
SVPVJ		MOVF	B2,W
		ADDWF	D2,F		;SH2+H2
		BTFSC	STATUS,C	;nepreteklo?
		INCF	D3,F		;NE, SH3+1
;--SOUCET P 256x SP+P=SP-----------------
		MOVF	P1,W
		ADDWF	D4,F		;SP1+P1
		BTFSS	STATUS,C	;preteklo?
		GOTO	SVPVP		;NE
		INCFSZ	D5,F		;SP2+1, =0?
		GOTO	SVPVP		;NE
		INCF	D6,F		;SP3+1
SVPVP		MOVF	P2,W
		ADDWF	D5,F		;SP2+P2
		BTFSC	STATUS,C	;nepreteklo?
		INCF	D6,F		;NE, SP3+1
;--VZORKY+1------------------------------
		INCFSZ	A1,F		;+1, =0?
		GOTO	Disp		;NE, preskocit vypocet
					;    a Program regulace
;----------------------------------------

; v D2,D3 je soucet urovneH / 256
; v D5,D6 je soucet Period / 256

;--NASOBENI D2,3 * 2128 = B1,2,3---------
		CLRF	B1		;vynulovat
		CLRF	B2		; B
		CLRF	B3		;
					;2048+64+16=2128
		MOVLW	11		;x2048
		CALL	Posuv		;11x *2 (11x posuv vlevo)
		MOVLW	6		;x64
		CALL	Posuv		;6x *2
		MOVLW	4		;x16
		CALL	Posuv		;4x *2
;--DELENI B1,2,3 / D5,6 = C1,2,3---------
		MOVF	B1,W		;BdoA
		MOVWF	A1		;
		MOVF	B2,W		;
		MOVWF	A2		;
		MOVF	B3,W		;
		MOVWF	A3		;
		MOVF	D5,W		;DdoB
		MOVWF	B1		;
		MOVF	D6,W		;
		MOVWF	B2		;
		CLRF	B3		;
		CALL	LOMENO		;A/B=C
;--PRUMER (C1,2 + OC1,2 = OC1,2) / 2 = A1,2 a D1,2
; C1,2 do OC1,2
		MOVF	C1,W
		ADDWF	OC1,F		;C1+OC1
		BTFSC	STATUS,C	;nepreteklo?
		INCF	OC2,F		;+1
		MOVF	C2,W
		ADDWF	OC2,F		;C2+OC2
		RRF	OC2,W		;/2
		MOVWF	A2		;vysledek2
		MOVWF	D2		;
		RRF	OC1,W		;/2
		MOVWF	A1		;vysledek1
		MOVWF	D1		;
		MOVF	C1,W		;CdoOC
		MOVWF	OC1		;
		MOVF	C2,W		;
		MOVWF	OC2		;
;--DIFERENCE-----------------------------
; jestli vstup>=vystup+5 tak vystup+1
		CLRF	A3
		MOVF	O2,W
		MOVWF	B2
		MOVF	O1,W
		ADDLW	5		;Dif.+4
		MOVWF	B1		;B+5
		BTFSC	STATUS,C	;nepreteklo?
		INCF	B2,F		;+1
		CLRF	B3
		CALL	DifTest
		BTFSS	STATUS,C	;kladne?
		GOTO	DifMinus
		INCFSZ	O1,F		;+1, =0?
		GOTO	DifEnd		;konec
		INCF	O2,F		;+1
		GOTO	DifEnd		;konec

;jestli vstup<=vystup tak vystup-1
DifMinus	MOVF	D1,W
		MOVWF	B1
		MOVF	D2,W
		MOVWF	B2
		MOVF	O1,W
		MOVWF	A1
		MOVF	O2,W
		MOVWF	A2
		CALL	DifTest
		BTFSS	STATUS,C	;kladne?
		GOTO	DifEnd		;Program;v Toleranci
		MOVLW	1
		SUBWF	O1,F		;-1
		BTFSS	STATUS,C	;kladne?
		DECF	O2,F		;-1
DifEnd		MOVF	O1,W
		MOVWF	A1
		MOVF	O2,W
		MOVWF	A2
;--MINUS A1,2 - 681 = C1,2---------------
; C1,2 do T1,2
		CLRF	A3
		MOVLW	0xA9		;(681=0x02A9)
		MOVWF	B1		;
		MOVLW	0x02		;
		MOVWF	B2		;
		CLRF	B3
		CALL	MINUS		;A-B=C
		MOVF	C1,W		;CdoT
		MOVWF	T1		;
		MOVF	C2,W		;
		MOVWF	T2		;
;--ZNAMENKO------------------------------
		BTFSS	STATUS,C	;C=1, kladne?
		GOTO	Zaporne		;NE
		BCF	Priznak,Znam	;znamenko=0, (nesviti)
		GOTO	HexDec
Zaporne		BSF	Priznak,Znam	;znamenko=1, (sviti)
		COMF	C1,F		;negace
		COMF	C2,F		;
		INCFSZ	C1,F		;+1, =0? (korekce)
		GOTO	HexDec
		INCF	C2,F		;
;--HEX/DEC-------------------------------
HexDec		CLRF	T1
		CLRF	T2
Rad100		MOVLW	100
		SUBWF	C1,W		;C1-100
		MOVWF	B1
		BTFSC	STATUS,C	;zaporne?
		GOTO	Uloz		;NE
		MOVLW	1
		SUBWF	C2,W		;C2-1
		BTFSS	STATUS,C	;kladne?
		GOTO	Rad10		;NE
		MOVWF	C2
		MOVF	B1,W
Uloz		MOVWF	C1
		INCF	T2,F		;+1
		GOTO	Rad100
Rad10		MOVLW	10
		SUBWF	C1,W		;C1-10
		BTFSS	STATUS,C	;kladne?
		GOTO	End10		;NE
		MOVWF	C1
		INCF	T1,F		;+1
		GOTO	Rad10
End10		MOVF	C1,W
		MOVWF	T0		;T0,1,2=vysledna teplota
;--OZNACIT ZAPORNE (nastavit bit7 T2)----
		BTFSC	Priznak,Znam	;kladne?
		BSF	T2,7		;NE, MSB=1
;--ZVOLENY PROGRAM-----------------------
Program		MOVF	Prog,W
		MOVWF	A3		;test Prog
		BTFSC	STATUS,Z	;Prog=0?
		GOTO	PROG0		;ANO
		DECF	A3,F		;test-1
		BTFSC	STATUS,Z	;=0?, Prog=1?
		GOTO	PROG1		;ANO
		DECF	A3,F		;test-1
		BTFSC	STATUS,Z	;=0?, Prog=2?
		GOTO	PROG2		;ANO
		DECF	A3,F		;test-1
		BTFSC	STATUS,Z	;=0?, Prog=3?
		GOTO	PROG3		;ANO
                DECF    A3,F            ;test-1
                BTFSC   STATUS,Z        ;=0?, Prog=4?
		GOTO	PROG4		;Prog=4
                GOTO    PROG5           ;Prog=5
;--VYNULOVAT SH,SP a Vzorky--------------
NulD		CLRF	D1		;SH
		CLRF	D2		;
		CLRF	D3		;
		CLRF	D4		;SP
		CLRF	D5		;
		CLRF	D6		;
		CLRF	A1		;Vzorky
;--DISPLEJ 3 mista-----------------------
Disp		DECFSZ	CDisplej,F	;citac-1, =0?
		GOTO	ImpP1		;NE
		MOVLW	7		;rychlost
		MOVWF	CDisplej	; zobrazovani
		DECFSZ	DPoradi,F	;-1; =0?
		GOTO	DJedna		;NE
;--Desetiny------------------------------
		MOVLW	3		;pocet mist displeje
		MOVWF	DPoradi
		MOVF	Disp0,W
		CALL	Segment
		BCF	PORTA,OD1	;OD1=0=VYP
		MOVWF	PORTB
		BSF	PORTA,OD0	;OD0=1=ZAP
		GOTO	ImpP1
;----------------------------------------
DJedna		DECFSZ	DPoradi,W	;-1, =0?
		GOTO	DDva		;NE
;--Jednicky------------------------------
		MOVF	Disp1,W
		CALL	Segment
		BCF	PORTA,OD2	;OD2=0=VYP
	;---Cteni klavesnice-------------
		MOVWF	A3		;schovat W
		MOVLW	255		;11111111
		MOVWF	PORTB		;prepnout na 1
		BSF	STATUS,RP0	;reg.sada1
		MOVWF	TRISB		;1=vstup
		BCF	STATUS,RP0	;reg.sada0
		MOVF	PORTB,W		;cte KLV
		MOVWF	KlvPort		;ulozit
		BSF	STATUS,RP0	;reg.sada1
		MOVLW	1		;00000001
		MOVWF	TRISB		;0=vystup
		BCF	STATUS,RP0	;reg.sada0
		MOVF	A3,W		;obnovit W
	;--------------------------------
		MOVWF	PORTB
		BSF	PORTA,OD1	;OD1=1=ZAP
		GOTO	ImpP1
;--Desitky-------------------------------
DDva		MOVF	Disp2,W
		CALL	Segment
		BCF	PORTA,OD0	;OD0=0=VYP
		MOVWF	PORTB
		BSF	PORTA,OD2	;OD2=1=ZAP
;--Impulsni vystup PROG1-----------------
ImpP1		DECFSZ	Prog,W		;test Prog-1, =0?
		GOTO	Mode		;NE
		DECFSZ	CImpuls,F	;CitacImpulsu-1, =0?
		GOTO	Prevod		;NE
		BSF	PORTA,ImpOut	;vystup=1
Prevod		INCFSZ	PT1,F		;Prevod Teploty+1, =0?
		GOTO	Mode		;NE
		INCFSZ	PT2,F		;+1, =0?
		GOTO	Mode		;NE
		BCF	PORTA,ImpOut	;vystup=0
		MOVLW	90		;obnovit
		MOVWF	CImpuls		; CitacImpulsu
		MOVF	O1,W		;nova hodnota
		MOVWF	PT1		; prevodu
		MOVF	O2,W		;  na impuls
		MOVWF	PT2		;
		RLF	PT1,F		;x2
		RLF	PT2,W		;
		ADDLW	0xED		;+11101101 237
		MOVWF	PT2		; korekce
;--MOD zobrazovani teplota=0,L=1,H=2,P=3
Mode		MOVF	MOD,W
		MOVWF	A3		;test MOD
		BTFSC	STATUS,Z	;=0?
		GOTO	MTeplomer	;ANO, teplota
		DECF	A3,F		;test-1
		BTFSC	STATUS,Z	;=0?, MOD=1?
		GOTO	MLow		;ANO, L
		DECF	A3,F		;test-1
		BTFSC	STATUS,Z	;=0?, MOD=2?
		GOTO	MHigh		;ANO, H
		DECF	A3,F		;test-1
		BTFSC	STATUS,Z	;=0?, MOD=3?
		GOTO	MProg		;ANO, P
;--MOD A=4,b=5,C=6,d=7-------------------
		MOVWF	EEADR		;cislo casovace v EEPROM
		ADDLW	6		;+6=znak(A,b,C,d)
		MOVWF	Disp0		;na displej0
		CALL	ERead
		MOVWF	B2		;casovac(TA,TB,TC,TD)
		ANDLW	0x0F		;00001111, dolni 4bity
		MOVWF	Disp1		;na displej1
		SWAPF	B2,W
		ANDLW	0x0F		;00001111, horni 4bity
		MOVWF	Disp2		;na displej2
		CALL	KLV
		BTFSC	STATUS,Z	;neco stisknuto?
		GOTO	Main		;NE
		BTFSS	KlvPort,TlM	;je to Tl.Minus?
		DECF	B2,F		;ANO, -1
		BTFSS	KlvPort,TlP	;je to Tl.Plus?
		INCF	B2,F		;ANO, +1
		BTFSS	KlvPort,TlD	;je to Tl.Dalsi?
		GOTO	ModPlus		;ANO
		MOVF	B2,W		;casovac(TA,TB,TC,TD)
		CALL	EWrite		;zapis
		MOVLW	1
		MOVWF	TB
		MOVWF	TD
		GOTO	Main
;========================================
MTeplomer	MOVF	T0,W		;teplota desetiny
		MOVWF	Disp0		;do displej0
		MOVF	T1,W		;teplota jednicky
		MOVWF	Disp1		;do displej1
		MOVF	T2,W		;teplota desitky
		CALL	MZnaky
		MOVWF	Disp2		;do displej2
		CALL	KLV
		BTFSS	STATUS,Z	;zadne tlacitko?
		BTFSC	KlvPort,TlD	;NE    ;stisknuto Tl.Dalsi?
		GOTO	Main		;konec ;NE, konec
;----------------------------------------
ModPlus		INCF	MOD,F		;+1
		MOVF	MOD,W
		XORLW	8
		BTFSC	STATUS,Z	;>7?
		CLRF	MOD		;ANO, MOD=0
		GOTO	Main
;========================================
MLow		MOVLW	0x14		;znak L
		MOVWF	Disp0		;do displej0
		MOVF	Low1,W		;mez jednicky
		MOVWF	Disp1		;do displej1
		MOVF	Low2,W		;mez desitky
		CALL	MZnaky
		MOVWF	Disp2		;do displej2
		CALL	KLV
		BTFSC	STATUS,Z	;neco stisknuto?
		GOTO	Main		;NE, konec
		BTFSS	KlvPort,TlM	;je stisknuto TlMinus?
		GOTO	MLMinus		;ANO
		BTFSS	KlvPort,TlP	;je stisknuto TlPlus?
		GOTO	MLPlus		;ANO
		BTFSS	Priznak,Zapis	;=1?
		GOTO	ModPlus
;zapis do EEPROM
		CLRF	EEADR		;adresa=0
		MOVF	Low2,W
		CALL	EWrite
		INCF	EEADR,F		;adresa+1=1
		MOVF	Low1,W
		CALL	EWrite
		BCF	Priznak,Zapis	;=0
		GOTO	ModPlus
;--Low -1 (MIN -40C)--------------------
MLMinus		BSF	Priznak,Zapis
		BTFSC	Low2,7		;MSB je VYP?
		GOTO	MLMplus		;NE
		MOVLW	1
		SUBWF	Low1,F		;jednicky-1
		BTFSC	STATUS,C	;zaporne?
		GOTO	Main		;NE
		SUBWF	Low2,F		;desitky-1
		BTFSS	STATUS,C	;kladne?
		GOTO	MLM1		;NE
		MOVLW	9
		MOVWF	Low1		;jednicki=9
		GOTO	Main
MLM1		MOVLW	0x80		;10000000
		MOVWF	Low2		;desitky=-0
		CLRF	Low1		;jednicky=0
MLMplus		MOVF	Low2,W
		SUBLW	0x83		;0x83-L
		BTFSS	STATUS,C	;kladne?
		GOTO	Main
		INCF	Low1,W		;jednicky+1
		MOVWF	Low1
		SUBLW	9		;9-L
		BTFSC	STATUS,C	;L>9?
		GOTO	Main		;NE
		CLRF	Low1		;jednicky=0
		INCF	Low2,F		;desitky+1
		GOTO	Main
;--Low +1 (MAX 130C)--------------------
MLPlus		BSF	Priznak,Zapis
		BTFSC	Low2,7		;MSB=0?
		GOTO	MLPminus	;NE
		MOVF	Low2,W
		SUBLW	12		;12-L
		BTFSS	STATUS,C	;L<=12?
		GOTO	Main		;NE
		INCF	Low1,W		;jednicky+1
		MOVWF	Low1
		SUBLW	9		;9-L
		BTFSC	STATUS,C	;L>9?
		GOTO	Main		;NE
		CLRF	Low1		;jednicky=0
		INCF	Low2,F		;desitky+1
		GOTO	Main
MLPminus	MOVLW	1
		SUBWF	Low1,F		;jednicky-1
		BTFSC	STATUS,C	;zaporne?
		GOTO	MLP1
		MOVLW	9
		MOVWF	Low1		;jednicky=9
		DECF	Low2,F		;desitky-1
MLP1		MOVF	Low2,W
		XORLW	0x80		;10000000
		BTFSS	STATUS,Z	;desitky=-0?
		GOTO	Main		;NE
		MOVF	Low1,F
		BTFSC	STATUS,Z	;jednicky neni 0?
		CLRF	Low2		;desitky=0
		GOTO	Main
;========================================
MHigh		MOVLW	0x10		;znak (H)
		MOVWF	Disp0		;do displej0
		MOVF	Hig1,W		;mez jednicky
		MOVWF	Disp1		;do displej1
		MOVF	Hig2,W		;mez desitky
		CALL	MZnaky
		MOVWF	Disp2		;do displej2
		CALL	KLV
		BTFSC	STATUS,Z	;neco stisknuto?
		GOTO	Main		;NE konec
		BTFSS	KlvPort,TlM	;je stisknuto TlMinus?
		GOTO	MHMinus		;minus
		BTFSS	KlvPort,TlP	;je stisknuto TlPlus?
		GOTO	MHPlus		;plus
		BTFSS	Priznak,Zapis	;=1?
		GOTO	ModPlus
;zapis do EEPROM
		MOVLW	2
		MOVWF	EEADR		;adresa=2
		MOVF	Hig2,W
		CALL	EWrite
		INCF	EEADR,F		;adresa+1=3
		MOVF	Hig1,W
		CALL	EWrite
		BCF	Priznak,Zapis	;=0
		GOTO	ModPlus
;--Hig -1 (MIN -40C)--------------------
MHMinus		BSF	Priznak,Zapis
		BTFSC	Hig2,7		;MSB je VYP?
		GOTO	MHMplus		;NE
		MOVLW	1
		SUBWF	Hig1,F		;jednicky-1
		BTFSC	STATUS,C	;zaporne?
		GOTO	Main		;NE
		SUBWF	Hig2,F		;desitky-1
		BTFSS	STATUS,C	;kladne?
		GOTO	MHM1		;NE
		MOVLW	9
		MOVWF	Hig1		;jednicki=9
		GOTO	Main
MHM1		MOVLW	0x80		;10000000
		MOVWF	Hig2		;desitky=-0
		CLRF	Hig1		;jednicky=0
MHMplus		MOVF	Hig2,W
		SUBLW	0x83		;83-L
		BTFSS	STATUS,C	;kladne?
		GOTO	Main
		INCF	Hig1,W		;jednicky+1
		MOVWF	Hig1
		SUBLW	9		;9-L
		BTFSC	STATUS,C	;L>9?
		GOTO	Main		;NE
		CLRF	Hig1		;jednicky=0
		INCF	Hig2,F		;desitky+1
		GOTO	Main
;--Hig +1 (MAX 130C)--------------------
MHPlus		BSF	Priznak,Zapis
		BTFSC	Hig2,7		;MSB=0?
		GOTO	MHPminus	;NE
		MOVF	Hig2,W
		SUBLW	12		;12-L
		BTFSS	STATUS,C	;L<=12?
		GOTO	Main		;NE
		INCF	Hig1,W		;jednicky+1
		MOVWF	Hig1
		SUBLW	9		;9-L
		BTFSC	STATUS,C	;L>9?
		GOTO	Main		;NE
		CLRF	Hig1		;jednicky=0
		INCF	Hig2,F		;desitky+1
		GOTO	Main
MHPminus	MOVLW	1
		SUBWF	Hig1,F		;jednicky-1
		BTFSC	STATUS,C	;zaporne?
		GOTO	MHP1
		MOVLW	9
		MOVWF	Hig1		;jednicky=9
		DECF	Hig2,F		;desitky-1
MHP1		MOVF	Hig2,W
		XORLW	0x80		;10000000
		BTFSS	STATUS,Z	;desitky=-0?
		GOTO	Main		;NE
		MOVF	Hig1,F
		BTFSC	STATUS,Z	;jednicky neni 0?
		CLRF	Hig2		;desitky=0
		GOTO	Main
;========================================
MProg		MOVLW	0x18		;znak (P)
		MOVWF	Disp0		;do dislpej0
		MOVF	Prog,W		;cislo programu
		MOVWF	Disp1		;do displej1
		MOVLW	0x20		;zadny znak
		MOVWF	Disp2		;do displej2
		CALL	KLV
		BTFSC	STATUS,Z	;neco stisknuto?
		GOTO	Main		;NE konec
		BTFSS	KlvPort,TlM	;je stisknuto TlMinus?
		GOTO	MPMinus		;minus
		BTFSS	KlvPort,TlP	;je stisknuto TlPlus?
		GOTO	MPPlus		;plus
		BTFSS	Priznak,Zapis	;=1?
		GOTO	ModPlus
;zapis do EEPROM
		MOVLW	8
		MOVWF	EEADR		;adresa=8
		MOVF	Prog,W
		CALL	EWrite
		BCF	Priznak,Zapis	;=0
		GOTO	ModPlus
;--Prog -1 (MIN 0)-----------------------
MPMinus		BSF	Priznak,Zapis	;=1
		MOVF	Prog,F
		BTFSS	STATUS,Z	;=0?
		DECF	Prog,F		;NE, -1
		GOTO	Main
;--Prog +1 (MAX 5)-----------------------
MPPlus		BSF	Priznak,Zapis	;=1
		MOVF	Prog,W
		XORLW	5
		BTFSS	STATUS,Z	;=5?
		INCF	Prog,F		;NE, +1
		GOTO	Main
;========================================
PROG0		BSF	PORTA,ReLow 	;VYP RLo
		BSF	PORTA,ReHig	;VYP RHi
		GOTO	NulD
;----------------------------------------
PROG1		CALL	HdoAB		; Ovladani ReleHig s hysterezi
		CALL	MENSI		;
		BTFSC	STATUS,C	;Teplota<H?
		BSF	PORTA,ReHig	;NE, ReleHi=1
		CALL	LdoAB
		CALL	VETSI
		BTFSC	STATUS,C	;Teplota>L?
		BCF	PORTA,ReHig	;NE, ReleHi=0
		GOTO	NulD
;----------------------------------------
PROG2		CALL	HdoAB		;priprava pro porovnani Hig meze
		CALL	VETSI		;Teplota>H C=0, jinak C=1
		CALL	ZVTHig		;C=0 CYKLOVAC ReleHi, C=1 VYP ReleHi
		CALL	LdoAB		;priprava pro porovnani L meze
		CALL	VETSI		;Teplota>H C=0, jinak C=1
		CALL	ZVTLow		;C=0 CYKLOVAC ReleLo, C=1 VYP ReleLo
		GOTO	NulD		;konec PROG
;----------------------------------------
PROG3		CALL	HdoAB
		CALL	MENSI		;Teplota<H
		CALL	ZVTHig
		CALL	LdoAB
		CALL	MENSI		;Teplota<L
		CALL	ZVTLow
		GOTO	NulD
;----------------------------------------
PROG4		CALL	HdoAB
		CALL	VETSI		;Teplota>H
		CALL	ZVTHig		;C=0 CYKLOVAC ReleHi, C=1 VYP ReleHi
		CALL	LdoAB
		CALL	MENSI		;Teplota<L
		CALL    ZVTLow		;C=0 CYKLOVAC ReleLo, C=1 VYP ReleLo
		GOTO	NulD
;----------------------------------------
PROG5		CALL	HdoAB
		CALL	VETSI		;T>H
		BTFSS	STATUS,C	;NE
		GOTO	ReZAV		;ANO
		CALL	LdoAB
		CALL	MENSI		;T<L
		BTFSS	STATUS,C	;NE
		GOTO	ReOTV		;ANO
		CALL	TrendAB
		CALL	VETSI		;T>Tr
		CALL	ZVTHig
		CALL	TrendAB
		CALL	MENSI		;T<Tr
		CALL	ZVTLow
		GOTO	NulD
ReZAV		BCF	PORTA,ReHig
		BSF	PORTA,ReLow
		GOTO	NTr
ReOTV		BCF	PORTA,ReLow
		BSF	PORTA,ReHig
NTr		CALL	NewTrend
		GOTO	NulD
;----------------------------------------
		END			; konec programu

